/***************************************************************************
                          HTMLPage.cpp  -  description
                             -------------------
    begin                : Fri Jan 5 2001
    copyright            : (C) 2001 by Sauro Menchetti
    email                : menco@inwind.it
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

// HTMLPage.cpp

#include "HTMLPage.h"
#include "Stem.h"
#include <fstream>
#include <cassert>

void HTMLPage::readHtmlPage()
{
	// open the html page
	std::ifstream is(pageFile.c_str());

	if (!is.is_open())
	{
		std::cerr << "Can't open the file " << pageFile << std::endl;		
		exit(-1);
	}

	// line of html page
	std::string line;

	// read vocabulary word from file and insert it in vocabulary vector
	while(std::getline(is, line) != 0)
	{
//std::cout << "line:#" << line << std::endl; std::cin.get();

        // erase the space characters at the end of line
        while (line.size() > 0 && isspace(*(line.end() - 1)))
        {
            line.erase(line.end() - 1);
        }

//std::cout << "line:#" << line << std::endl; std::cin.get();
		
		htmlPage += line + " ";		
//std::cout << "htmlPage:#" << htmlPage << std::endl; std::cin.get();
	}

	// close the html page
	is.close();
}

void HTMLPage::eraseHtmlTag(std::string& section)
{
//std::cout << section << std::endl; std::cin.get();
//for (unsigned int i = 0; i < section.size(); ++i) std::cout << i << ") " << (unsigned int)section[i] << " " << section[i] << " "; std::cout << std::endl;

	////////////////////////////////////
	// log file for comments and tags //
	////////////////////////////////////
	/*std::string file = pageFile;
	file.erase(0, 2);
	unsigned int len = file.size();
	for (unsigned int i = 0; i < len; ++i)
	{
		if (file[i] == '/')
		{
			file[i] = '+';
		}
	}
	std::string log_file = "./log/" + file + "_log"; // std::cout << log_file << std::endl;
	std::ofstream of(log_file.c_str());
	assert(of.is_open());*/

	////////////////////////
	// ERASE THE COMMENTS //
	////////////////////////

	// the html comments init whit "<!--" and finisn with "-->"
	string::size_type pos_1 = section.find("<!--");
	string::size_type pos_2 = section.find("-->");

	// while there are html tags in the page
	while (pos_1 != std::string::npos)
	{
		if ((pos_1 < pos_2) && (pos_2 != std::string::npos))
		{
			std::string comment = section.substr(pos_1, pos_2 - pos_1 + 3);
///////////////////////////////////////////////
//of << comment << std::endl; // std::cin.get();
///////////////////////////////////////////////

			// erase the html tag
			section.erase(pos_1, pos_2 - pos_1 + 3);

			pos_1 = section.find("<!--");
			pos_2 = section.find("-->");
		}
		// if there is "<!--", "-->" must be in the html page
		else if (pos_2 == std::string::npos)
		{
///////////////////////////////////////////////////////////////////////////
//std::cout << "There is <!-- but not -->." << std::endl; // std::cin.get();
///////////////////////////////////////////////////////////////////////////

			// erase <!--
			section.erase(pos_1, 4);

			pos_1 = std::string::npos;
		}
		else if (pos_1 > pos_2)
		{
////////////////////////////////////////////////////////////////////////
//std::cout << "pos_1 > pos_2: <!-- -->" << std::endl; // std::cin.get();
////////////////////////////////////////////////////////////////////////

			while (pos_1 > pos_2)
			{

//std::cout << "section lenght: " << section.size() << std::endl;
//std::cout << "pos_1: " << pos_1 << std::endl;
//std::cout << "pos_2: " << pos_2 << std::endl;  std::cin.get();

				if (pos_2 != std::string::npos)
				{

//std::cout << "section lenght: " << section.size() << std::endl;
//std::cout << "pos_1: " << pos_1 << std::endl;
//std::cout << "pos_2: " << pos_2 << std::endl;  std::cin.get();

					section.erase(pos_2, 3);
					pos_1 = section.find("<!--");
					pos_2 = section.find("-->");
				}

//std::cout << "section lenght: " << section.size() << std::endl;
//std::cout << "pos_1: " << pos_1 << std::endl;
//std::cout << "pos_2: " << pos_2 << std::endl;  std::cin.get();

			}
		}
    }

	/*if (pos_2 != std::string::npos)
	{
		std::cout << "There is --> but not <!--." << std::endl; std::cin.get();
		assert (pos_1 != std::string::npos);
	}*/

	/////////////////////////////////////////////
	// ERASE META HTML TAG WITHOUT ITS CONTENT //
	/////////////////////////////////////////////

//std::cout << section << "##" << std::endl; std::cin.get();

	// erase html key words in the html tag meta
	std::string meta = "<meta";

	string::size_type pos = std::string::npos;

	while ((pos = section.find(meta)) != std::string::npos)
	{
		section.erase(pos, meta.size());
	}

//std::cout << section << "##" << std::endl; std::cin.get();

	/////////////////////////
	// ERASE THE HTML TAGS //
	/////////////////////////

	// the html tags init whit "<" and finisn with ">"
	pos_1 = section.find("<");
	pos_2 = section.find(">");

//std::cout << "pos_1: " << pos_1 << std::endl;
//std::cout << "pos_2: " << pos_2 << std::endl; std::cin.get();

	// while there are html tags in the page
	while (pos_1 != std::string::npos)
	{
		if ((pos_1 < pos_2) && (pos_2 != std::string::npos))
		{
			// tag of html page
			std::string tag = section.substr(pos_1, pos_2 - pos_1 + 1);
///////////////////////////////////////////
//of << tag << std::endl; // std::cin.get();
///////////////////////////////////////////

			// erase the html tag
			section.erase(pos_1, pos_2 - pos_1 + 1);

			pos_1 = section.find("<");
			pos_2 = section.find(">");
		}
		// if there is "<", ">" must be in the html page
		else if (pos_2 == std::string::npos)
		{
/////////////////////////////////////////////////////////////////////
//std::cout << "There is < but not >" << std::endl; // std::cin.get();
/////////////////////////////////////////////////////////////////////

			// erase <
			section.erase(pos_1, 1);

			pos_1 = std::string::npos;
		}
		else if (pos_1 > pos_2)
		{
//////////////////////////////////////////////////////////////////
//std::cout << "pos_1 > pos_2: <>" << std::endl; // std::cin.get();
//////////////////////////////////////////////////////////////////

			while (pos_1 > pos_2)
			{

//std::cout << "section lenght: " << section.size() << std::endl;
//std::cout << "pos_1: " << pos_1 << std::endl;
//std::cout << "pos_2: " << pos_2 << std::endl;  std::cin.get();

				if (pos_2 != std::string::npos)
				{

//std::cout << "section lenght: " << section.size() << std::endl;
//std::cout << "pos_1: " << pos_1 << std::endl;
//std::cout << "pos_2: " << pos_2 << std::endl;  std::cin.get();

					section.erase(pos_2, 1);
					pos_1 = section.find("<");
					pos_2 = section.find(">");		
				}

//std::cout << "section lenght: " << section.size() << std::endl;
//std::cout << "pos_1: " << pos_1 << std::endl;
//std::cout << "pos_2: " << pos_2 << std::endl;  std::cin.get();

			}
		}
	}

	/*if (pos_2 != std::string::npos)
	{
		std::cout << "There is > but not <" << std::endl;
		assert (pos_1 != std::string::npos);
	}*/

	// close the log file
/////////////
//of.close();
/////////////
}

void HTMLPage::eraseMetaTag(std::string& section)
{
//std::cout << section << "##fine##" << std::endl; std::cin.get();

	// html key words in the html tag meta
	std::string meta        = "meta";
	std::string name        = "name";
	std::string content     = "content";
	std::string description = "description";
	std::string keywords    = "keywords";

	string::size_type pos = std::string::npos;

	// erase html key words in the html tag meta
	while ((pos = section.find(meta)) != std::string::npos)
	{
		section.erase(pos, meta.size());
	}
	while ((pos = section.find(name)) != std::string::npos)
	{
		section.erase(pos, name.size());
	}
	while ((pos = section.find(content)) != std::string::npos)
	{
		section.erase(pos, content.size());
	}
	while ((pos = section.find(description)) != std::string::npos)
	{
		section.erase(pos, description.size());
	}
	while ((pos = section.find(keywords)) != std::string::npos)
	{
		section.erase(pos, keywords.size());
	}

//std::cout << section << "##fine##" << std::endl; std::cin.get();
}

void HTMLPage::eraseNotAlpha(std::string& section)
{
	unsigned int lenght = section.size();

	for (unsigned int i = 0; i < lenght; ++i)
	{
		if (!isalpha(section[i]))
		{
			section[i] = ' ';
		}
	}
}

void HTMLPage::caseInsensitive(std::string& section)
{
	unsigned int lenght = section.size();

	for (unsigned int i = 0; i < lenght; ++i)
	{
		if (!islower(section[i]))
		{
			section[i] = tolower(section[i]);
		}
	}
}

void HTMLPage::makeToken(std::string section, std::vector<std::string>& setToken)
{
	// maximun lenght of token
	unsigned int max_lenght_token = 50;

	// token of the html page
	std::string token;

    // erase the space at the beginning of html page
    while (section.size() > 0 && isspace(*section.begin()))
    {
		section.erase(section.begin());
    }

	// while the html page isn't empty
    while (section != "")
    {
//std::cout << "section without begin space:#" << section << "#" << std::endl; std::cin.get();

		// lenght of html page
        unsigned int section_lenght = section.size();

		// indicate if we have found a token
        bool token_found = false;

		unsigned int i;

        for (i = 0; (i < section_lenght) && (!token_found); ++i)
        {
            if (isspace(section[i]))
            {
                token_found = true;
            }
        }

		if (token_found)
		{
			// select the token
    	    token = section.substr(0, i - 1);

//std::cout << "token:#" << token << "#" << std::endl;

			if (token != "" && token.size() < max_lenght_token)
			{
				// add the token to the vector of token
				setToken.push_back(token);
			}

			// erase the token from the html page
        	section.erase(0, i);

//std::cout << "htmlpage without token:#" << htmlpage << "#" << std::endl; std::cin.get();
		
		    // erase the space after the token
    	    while (section.size() > 0 && isspace(*section.begin()))
        	{
    	       	section.erase(section.begin());
	        }
		}

//std::cout << "htmlpage without space after token" << std::endl; std::cin.get();
	}	
}

void HTMLPage::eraseStopWords(std::string stopWordsFileName)
{
	// open the stop words file
	std::ifstream istop(stopWordsFileName.c_str());

	if (!istop.is_open())
	{
		std::cerr << "Can't open the file " << stopWordsFileName << std::endl;		
		exit(-1);
	}

	// vector of stop words
	std::vector<std::string> stopWordsVector;

	// stop word
	std::string stopWord;

	while(std::getline(istop, stopWord) != 0)
	{
	    // erase the space at the end of stop word
		stopWord.erase(stopWord.end() - 1);

//std::cout << "stop word :#" << stopWord << "#" << std::endl; std::cin.get();

		// add the stop word in the vector of stop words
		stopWordsVector.push_back(stopWord);
	}

    // close the stop words file
	istop.close();

//for (unsigned int i = 0; i < stopWordsVector.size(); ++i) { std::cout << stopWordsVector[i] << std::endl; } std::cin.get();

	// token number
	unsigned int token_number = tokenVector.size();

	// stop words number
	unsigned int stopWords_number = stopWordsVector.size();

	// token index
	unsigned int ti;

	// stop word index
	unsigned int si;

	// temporary token vector
	std::vector<std::string> tmp_tokenVector;

	for (ti = 0; ti < token_number; ++ti)
	{
		// indicate if the token is a stop word
		bool isstopword = false;

		for (si = 0; si < stopWords_number && !isstopword; ++si)
		{

//std::cout << "token:#" << tokenVector[ti] << "#" << std::endl;
//std::cout << "stopw:#" << stopWordsVector[si] << "#" << std::endl; std::cin.get();

			if (tokenVector[ti] == stopWordsVector[si])
			{
				isstopword = true;
			}
		}

		if (!isstopword)
		{
			tmp_tokenVector.push_back(tokenVector[ti]);
		}
	}

	tokenVector = tmp_tokenVector;
}

void HTMLPage::stemming(std::vector<std::string>& setToken)
{
	unsigned int token_number = setToken.size();
	
	for (unsigned int ti = 0; ti < token_number; ++ti)
	{
		char* p_token = 0;
		char* p_tmp = const_cast<char*>(setToken[ti].c_str());
		p_token = new char[strlen(p_tmp) + 1];
		strcpy(p_token, p_tmp);

//std::cout << "token before stemming:#" << setToken[ti] << "#" << std::endl; // std::cin.get();

		// stem the token
        stem_porter(p_token);

        std::string token = p_token;

//std::cout << "token lenght after stemming: " << token.size() << std::endl;

		// to avoid token of lenght 1
		if (token.size() > 1)
		{
			setToken[ti] = token;
		}

//std::cout << "token after stemming:#" << setToken[ti] << "#" << std::endl;  std::cin.get();
	}
}

void HTMLPage::processing_for_create_vocabulary(std::string stopWordsFileName)
{
	// make the page case insensitive
	caseInsensitive(htmlPage);

//std::cout << "HTML PAGE CASE INSENSITIVE" << std::endl << *this << std::endl; // std::cin.get();

	///////////////////////////////////////
	// erase tags and comments from page //
	///////////////////////////////////////
	eraseHtmlTag(htmlPage);

//std::cout << "HTML WITHOUT HTML TAGS" << std::endl << *this << std::endl; // std::cin.get();

	// erase not alphebetic characters
	eraseNotAlpha(htmlPage);

//std::cout << "HTML WITHOUT ALPHABETIC CHARACTERS" << std::endl << *this << std::endl; // std::cin.get();

	// split tha html page in token
	makeToken(htmlPage, tokenVector);

//std::cout << "HTML PAGE TOKEN" << std::endl << *this << std::endl; std::cin.get();

	//////////////////////////
	// erase a list of word //
	//////////////////////////
	eraseStopWords(stopWordsFileName);

//std::cout << "WITHOUT STOP WORD" << std::endl << *this << std::endl; std::cin.get();

	/////////////////////////////////////////
	// stemming the token of the html page //
	/////////////////////////////////////////
	stemming(tokenVector);

//std::cout << "AFTER STEMMING" << std::endl << *this << std::endl; // std::cin.get();
}

void HTMLPage::allocateBagOfWords(unsigned int vocabulary_word_number)
{
	bag_of_words.resize(vocabulary_word_number);

	for (unsigned int i = 0; i < vocabulary_word_number; ++i)
	{
		bag_of_words[i] = 0.0;
	}
}

std::string HTMLPage::findSection(std::string begin, std::string end, std::string& section)
{
//std::cin.get();
//std::cout << "section findSection()" << std::endl << section << "##fine##" << std::endl;
//std::cout << "begin:#" << begin << "#" << std::endl;
//std::cout << "end:#"   << end   << "#" << std::endl; // std::cin.get();

	// erase the two tags and the text between the two tags from section
	// and copy text and two tags in subsection

	// section between the tags: init whit empty string
	std::string subsection = "";

	// find the position of two html tags
	string::size_type pos_1 = section.find(begin);
	string::size_type pos_2 = section.find(end);

	// while there are the two html tags in the page
	while (pos_1 != std::string::npos)
	{
		// if there is the first tag, must be also the second
		if (pos_2 == std::string::npos)
		{
			std::cout << "There is the first tag but not the second." << std::endl;
			assert (pos_2 != std::string::npos);
		}

//std::cout << "pos_1: " << pos_1 << std::endl;
//std::cout << "pos_2: " << pos_2 << std::endl; // std::cin.get();

		// text between two tags with the two tags
		std::string textandtags = section.substr(pos_1, pos_2 - pos_1 + end.size());

//std::cout << "text and tags:" << std::endl << textandtags << "##fine##" << std::endl; // std::cin.get();

		// add text and two tags to subsection
		subsection += textandtags + " ";

		// erase two html tags and the text between two tags
		section.erase(pos_1, pos_2 - pos_1 + end.size());

//std::cout << section << std::endl; // std::cin.get();

		pos_1 = section.find(begin);
		pos_2 = section.find(end);
	}

	if (pos_2 != std::string::npos)
	{
		std::cout << "There is the second tag but not the first." << std::endl;
		assert (pos_1 != std::string::npos);
	}

//std::cout << "Subsection end findSection()" << std::endl << subsection << "##fine##" << std::endl;

	return subsection;
}

void HTMLPage::createBagOfWords(const Vocabulary& vocabulary)
{
	// vocabulary map and its iterator
    std::map<std::string, unsigned int> vocabulary_map = vocabulary.getVocabulary_map();
	std::map<std::string, unsigned int>::const_iterator it_voc_map;

	// vector of IDF
	std::vector<double> vector_idf;

	// file of IDF
	std::ifstream is_idf("./inverse_document_frequency");

	if (!is_idf.is_open())
	{
		std::cerr << "Can't open the file ./inverse_document_frequency" << std::endl;		
		exit(-1);
	}

	// line of html page
	std::string idf_string;

	// read vocabulary word from file and insert it in vocabulary vector
	while(std::getline(is_idf, idf_string) != 0)
	{
		double idf = atof(idf_string.c_str());
		vector_idf.push_back(idf);
	}

	// close the IDF file
	is_idf.close();

//for (unsigned int j = 0; j < vector_idf.size(); ++j) { std::cout << vector_idf[j] << std::endl; } std::cin.get();

	// number of token of html page sections
	unsigned int token_number_title     = tokenVector_title.size();
	unsigned int token_number_meta      = tokenVector_meta.size();
	unsigned int token_number_h1        = tokenVector_h1.size();
	unsigned int token_number_link      = tokenVector_link.size();
	unsigned int token_number_h2        = tokenVector_h2.size();
	unsigned int token_number_h3        = tokenVector_h3.size();
	unsigned int token_number_plaintext = tokenVector_plaintext.size();

	unsigned int i;

	// processing token of title
	for (i = 0; i < token_number_title; ++i)
	{
		it_voc_map = vocabulary_map.find(tokenVector_title[i]);

		// if the token is in vocabulary
		if (it_voc_map != vocabulary_map.end())
		{
			// bag_of_words[i] = TF(wi, d) * IDF(wi)
			bag_of_words[it_voc_map->second] += weight.find("title")->second * vector_idf[it_voc_map->second];
		}
	}

	// processing token of meta
	for (i = 0; i < token_number_meta; ++i)
	{
		it_voc_map = vocabulary_map.find(tokenVector_meta[i]);

		// if the token is in vocabulary
		if (it_voc_map != vocabulary_map.end())
		{
			// bag_of_words[i] = TF(wi, d) * IDF(wi)
			bag_of_words[it_voc_map->second] += weight.find("meta")->second * vector_idf[it_voc_map->second];
		}
	}

	// processing token of h1
	for (i = 0; i < token_number_h1; ++i)
	{
		it_voc_map = vocabulary_map.find(tokenVector_h1[i]);

		// if the token is in vocabulary
		if (it_voc_map != vocabulary_map.end())
		{
			// bag_of_words[i] = TF(wi, d) * IDF(wi)
			bag_of_words[it_voc_map->second] += weight.find("h1")->second * vector_idf[it_voc_map->second];
		}
	}

	// processing token of link
	for (i = 0; i < token_number_link; ++i)
	{
		it_voc_map = vocabulary_map.find(tokenVector_link[i]);
		// if the token is in vocabulary
		if (it_voc_map != vocabulary_map.end())
		{
			// bag_of_words[i] = TF(wi, d) * IDF(wi)
			bag_of_words[it_voc_map->second] += weight.find("link")->second * vector_idf[it_voc_map->second];
		}
	}

	// processing token of h2
	for (i = 0; i < token_number_h2; ++i)
	{
		it_voc_map = vocabulary_map.find(tokenVector_h2[i]);

		// if the token is in vocabulary
		if (it_voc_map != vocabulary_map.end())
		{
			// bag_of_words[i] = TF(wi, d) * IDF(wi)
			bag_of_words[it_voc_map->second] += weight.find("h2")->second * vector_idf[it_voc_map->second];
		}
	}

	// processing token of h3
	for (i = 0; i < token_number_h3; ++i)
	{
		it_voc_map = vocabulary_map.find(tokenVector_h3[i]);

		// if the token is in vocabulary
		if (it_voc_map != vocabulary_map.end())
		{
			// bag_of_words[i] = TF(wi, d) * IDF(wi)
			bag_of_words[it_voc_map->second] += weight.find("h3")->second * vector_idf[it_voc_map->second];
		}
	}

	// processing token of plaintext
	for (i = 0; i < token_number_plaintext; ++i)
	{
		it_voc_map = vocabulary_map.find(tokenVector_plaintext[i]);

		// if the token is in vocabulary
		if (it_voc_map != vocabulary_map.end())
		{
			// bag_of_words[i] = TF(wi, d) * IDF(wi)
			bag_of_words[it_voc_map->second] += weight.find("plaintext")->second * vector_idf[it_voc_map->second];
		}
	}
}

void HTMLPage::processing_for_create_bag_of_words(const Vocabulary& vocabulary)
{
	// copy of html page
	htmlPage_plaintext = htmlPage;

	// make the page case insensitive
	caseInsensitive(htmlPage_plaintext);

	// find the words that are between the tags and split the document in sections
	htmlPage_title = findSection("<title>", "</title>", htmlPage_plaintext);
	htmlPage_meta  = findSection("<meta ",  "/>",       htmlPage_plaintext);
	htmlPage_h1    = findSection("<h1>",    "</h1>",    htmlPage_plaintext);
	htmlPage_link  = findSection("<a ",     "</a>",     htmlPage_plaintext);
	htmlPage_h2    = findSection("<h2>",    "</h2>",    htmlPage_plaintext);
	htmlPage_h3    = findSection("<h3>",    "</h3>",    htmlPage_plaintext);

	// erase tags and comments
	eraseHtmlTag(htmlPage_title);
	eraseMetaTag(htmlPage_meta);
	eraseHtmlTag(htmlPage_h1);
	eraseHtmlTag(htmlPage_link);
	eraseHtmlTag(htmlPage_h2);
	eraseHtmlTag(htmlPage_h3);
	eraseHtmlTag(htmlPage_plaintext);

	// erase not alphebetic characters
	eraseNotAlpha(htmlPage_title);
	eraseNotAlpha(htmlPage_meta);
	eraseNotAlpha(htmlPage_h1);
	eraseNotAlpha(htmlPage_link);
	eraseNotAlpha(htmlPage_h2);
	eraseNotAlpha(htmlPage_h3);
	eraseNotAlpha(htmlPage_plaintext);

	// split the section in token
	makeToken(htmlPage_title,     tokenVector_title);
	makeToken(htmlPage_meta,      tokenVector_meta);
	makeToken(htmlPage_h1,        tokenVector_h1);
	makeToken(htmlPage_link,      tokenVector_link);
	makeToken(htmlPage_h2,        tokenVector_h2);
	makeToken(htmlPage_h3,        tokenVector_h3);
	makeToken(htmlPage_plaintext, tokenVector_plaintext);

	// stemming the token of section
	stemming(tokenVector_title);
	stemming(tokenVector_meta);
	stemming(tokenVector_h1);
	stemming(tokenVector_link);
	stemming(tokenVector_h2);
	stemming(tokenVector_h3);
	stemming(tokenVector_plaintext);

	// create the bag of words of html page
	createBagOfWords(vocabulary);
}

std::ostream& operator<<(std::ostream& os, const HTMLPage& htmlPage)
{
	unsigned int i;

	std::string pageFile = htmlPage.getPageFile();
	os << "File of HTML Page:" << std::endl << pageFile << std::endl;

	std::string htmlpage = htmlPage.getHtmlPage();
	os << std::endl << "HTML PAGE:" << std::endl << htmlpage << "##fine##" << std::endl;

	std::vector<std::string> tokenVector = htmlPage.getTokenVector();
	unsigned int token_number = tokenVector.size();
	os << "TOKEN:" << std::endl;
	for (i = 0; i < token_number; ++i)
	{
		os << tokenVector[i] << " ";
	}
	os << "##fine##" << std::endl;

	std::string htmlpage_title = htmlPage.getHtmlPage_title();
	os << std::endl << "HTML PAGE TITLE:" << std::endl << htmlpage_title << "##fine##" << std::endl;

	std::string htmlpage_meta = htmlPage.getHtmlPage_meta();
	os << std::endl << "HTML PAGE META:" << std::endl << htmlpage_meta << "##fine##" << std::endl;

	std::string htmlpage_h1 = htmlPage.getHtmlPage_h1();
	os << std::endl << "HTML PAGE H1:" << std::endl << htmlpage_h1 << "##fine##" << std::endl;

	std::string htmlpage_link = htmlPage.getHtmlPage_link();
	os << std::endl << "HTML PAGE LINK:" << std::endl << htmlpage_link << "##fine##" << std::endl;

	std::string htmlpage_h2 = htmlPage.getHtmlPage_h2();
	os << std::endl << "HTML PAGE H2:" << std::endl << htmlpage_h2 << "##fine##" << std::endl;

	std::string htmlpage_h3 = htmlPage.getHtmlPage_h3();
	os << std::endl << "HTML PAGE H3:" << std::endl << htmlpage_h3 << "##fine##" << std::endl;

	std::string htmlpage_plaintext = htmlPage.getHtmlPage_plaintext();
	os << std::endl << "HTML PAGE PLAINTEXT:" << std::endl << htmlpage_plaintext << "##fine##" << std::endl;

	std::vector<std::string> tokenVector_title = htmlPage.getTokenVector_title();
	unsigned int token_number_title = tokenVector_title.size();
	os << "TOKEN TITLE:" << std::endl;
	for (i = 0; i < token_number_title; ++i)
	{
		os << tokenVector_title[i] << " ";
	}
	os << "##fine##" << std::endl;

	std::vector<std::string> tokenVector_meta = htmlPage.getTokenVector_meta();
	unsigned int token_number_meta = tokenVector_meta.size();
	os << "TOKEN META:" << std::endl;
	for (i = 0; i < token_number_meta; ++i)
	{
		os << tokenVector_meta[i] << " ";
	}
	os << "##fine##" << std::endl;

	std::vector<std::string> tokenVector_h1 = htmlPage.getTokenVector_h1();
	unsigned int token_number_h1 = tokenVector_h1.size();
	os << "TOKEN H1:" << std::endl;
	for (i = 0; i < token_number_h1; ++i)
	{
		os << tokenVector_h1[i] << " ";
	}
	os << "##fine##" << std::endl;

	std::vector<std::string> tokenVector_link = htmlPage.getTokenVector_link();
	unsigned int token_number_link = tokenVector_link.size();
	os << "TOKEN LINK:" << std::endl;
	for (i = 0; i < token_number_link; ++i)
	{
		os << tokenVector_link[i] << " ";
	}
	os << "##fine##" << std::endl;

	std::vector<std::string> tokenVector_h2 = htmlPage.getTokenVector_h2();
	unsigned int token_number_h2 = tokenVector_h2.size();
	os << "TOKEN H2:" << std::endl;
	for (i = 0; i < token_number_h2; ++i)
	{
		os << tokenVector_h2[i] << " ";
	}
	os << "##fine##" << std::endl;

	std::vector<std::string> tokenVector_h3 = htmlPage.getTokenVector_h3();
	unsigned int token_number_h3 = tokenVector_h3.size();
	os << "TOKEN H3:" << std::endl;
	for (i = 0; i < token_number_h3; ++i)
	{
		os << tokenVector_h3[i] << " ";
	}
	os << "##fine##" << std::endl;

	std::vector<std::string> tokenVector_plaintext = htmlPage.getTokenVector_plaintext();
	unsigned int token_number_plaintext = tokenVector_plaintext.size();
	os << "TOKEN PLAINTEXT:" << std::endl;
	for (i = 0; i < token_number_plaintext; ++i)
	{
		os << tokenVector_plaintext[i] << " ";
	}
	os << "##fine##" << std::endl;

	std::map<std::string, double> weight = htmlPage.getWeight();
	std::map<std::string, double>::const_iterator it_weight;
	for (it_weight = weight.begin(); it_weight != weight.end(); ++it_weight)
	{
    	os << it_weight->first << "\t" << it_weight->second << std::endl;
	}

	std::vector<double> bag_of_words = htmlPage.getBag_of_words();
	unsigned int vocabulary_word_number = bag_of_words.size();
	os << "BAG OF WORDS" << std::endl;
	for (unsigned int j = 0; j < vocabulary_word_number; ++j)
	{
		os << "index: " << bag_of_words[j] << "\t" << "weight: " << bag_of_words[j] << std::endl;
	}
	os << "##fine##" << std::endl;

	return os;
}

